#include "stdafx.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdarg.h>
#include "syntax.h"
#include "peak.h"


extern double get_sim_time(TokenString &);

//**************************************************************************

double PeakTrackObj::Evaluate()
   {
     if ( *tptr >= T1 && *tptr <= T2 ) {
       if ( !startFlag ) { startFlag = true; peak = *pointer; }
       else if ( isMax ) {  if ( *pointer > peak )  peak = *pointer; }
            else  if ( *pointer < peak )  peak = *pointer;
     }

   return peak;
   }

//*******************************************************************************

PeakTrackObj::PeakTrackObj(TokenString &Param, const char *minmax, int i)
   {
   isMax = equal(minmax,"max") ? true : false;
   startFlag = false;
   // strcpy(MinMax, minmax);

   long p = Param.token_index(minmax, i+1) - 1;

   ID = Param.getVarName(p, "min/max tracking variable");

   varPos = p + 2;
   varName = Param.StrCpy( varPos );
   
   T1 = Param.get_double(p + 3);
   T2 = Param.get_double(p + 4);
   double Tmax = get_sim_time(Param);

   if (T1 < 0) T1 = 0.0;
   if (T2 > Tmax) T2 = Tmax;

   if ( T1 >= T2 ) Param.errorMessage(p + 3, 
                   makeMessage("Zero time interval length in \"%s\" object: [ %g, %g ]", minmax, T1, T2) );
   if (VERBOSE)
       fprintf(stdlog,"  #  %s = %s of %s on [%g,%g] \n", ID, minmax, varName, T1, T2);
   }


//*******************************************************************************
//*******************************************************************************
/*
void PeakTrackArray::copy(const PeakTrackArray& PTA)  
{ 
    peak_num = PTA.peak_num;
    array = new PeakTrackObj *[peak_num];

    for (int i = 0; i < peak_num; i++)
      array[i] = new PeakTrackObj(*PTA.array[i]); 
}    
*/
//*******************************************************************************

PeakTrackArray::PeakTrackArray(TokenString &Param)
{
  int min_num = Param.token_count("min");
  int max_num = Param.token_count("max");

  peak_num = min_num + max_num;

  array = new PeakTrackObj *[peak_num];

  if (peak_num && VERBOSE) 
       fprintf(stdlog,"\n### Setting up %d extremum tracking variable(s):\n", peak_num);

  int i;

  for (i = 0; i < max_num; i++)  array[i] = new PeakTrackObj(Param, "max", i);
  for (i = 0; i < min_num; i++)  array[i + max_num] = new PeakTrackObj(Param, "min", i);

}

//*******************************************************************************


void PeakTrackObj::set_pointer(TokenString &Param, class VarList *VL)
{

  if ( ! ( pointer = VL->ResolveID( varName, &tptr ) ) )
      Param.errorMessage(varPos, 0, "Cannot track min/max of an undefined variable");
  
}

//*******************************************************************************//*******************************************************************************


void PeakTrackArray::set_pointers(TokenString &Param, class VarList *VL)
{

  for (int i = 0; i < peak_num; i++ )  array[i]->set_pointer(Param, VL);
  
}

//*******************************************************************************
